diff --git a/web/regression/javascript/backup/global_server_backup_dialog_spec.js b/web/regression/javascript/backup/global_server_backup_dialog_spec.js
new file mode 100644
index 00000000..0b229038
--- /dev/null
+++ b/web/regression/javascript/backup/global_server_backup_dialog_spec.js
@@ -0,0 +1,585 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2018, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import {BackupDialog} from '../../../pgadmin/static/js/backup/backup_dialog';
+import {TreeFake} from '../tree/tree_fake';
+import MockAdapter from 'axios-mock-adapter';
+import axios from 'axios/index';
+import {FakeModel} from '../fake_model';
+
+const context = describe;
+
+describe('GlobalServerBackupDialog', () => {
+  let backupDialog;
+  let backupNode;
+  let pgBrowser;
+  let jquerySpy;
+  let alertifySpy;
+  let backupModelSpy;
+  let backform;
+
+
+  let rootNode;
+  let serverTreeNode;
+  let ppasServerTreeNode;
+  let noDataNode;
+
+  beforeEach(() => {
+    pgBrowser = {
+      treeMenu: new TreeFake(),
+      Nodes: {
+        server: jasmine.createSpyObj('Node[server]', ['getTreeNodeHierarchy']),
+      }
+    };
+    pgBrowser.Nodes.server.hasId = true;
+    jquerySpy = jasmine.createSpy('jquerySpy');
+    backupModelSpy = jasmine.createSpy('backupModelSpy');
+    backupNode = {};
+    backform = jasmine.createSpyObj('backform', ['generateViewSchema', 'Dialog']);
+
+    rootNode = pgBrowser.treeMenu.addNewNode('level1', {}, []);
+    serverTreeNode = pgBrowser.treeMenu.addNewNode('level1.1', {
+      _type: 'server',
+      _id: 10,
+    }, ['level1']);
+    ppasServerTreeNode = pgBrowser.treeMenu.addNewNode('level1.2', {
+      _type: 'server',
+      server_type: 'ppas',
+    }, ['level1']);
+    pgBrowser.treeMenu.addNewNode('level3', {}, ['level1', 'level1.2']);
+    noDataNode = pgBrowser.treeMenu.addNewNode(
+      'level3.1', undefined, ['level1', 'level1.2', 'level3']);
+  });
+
+  describe('#draw', () => {
+    beforeEach(() => {
+      alertifySpy = jasmine.createSpyObj('alertify', ['alert', 'dialog']);
+      alertifySpy['BackupDialog_globals'] = jasmine.createSpy('BackupDialog_globals');
+      alertifySpy['BackupDialog_server'] = jasmine.createSpy('BackupDialog_server');
+      backupDialog = new BackupDialog(
+        pgBrowser,
+        jquerySpy,
+        alertifySpy,
+        backupModelSpy
+      );
+
+      pgBrowser.get_preference = jasmine.createSpy('get_preferences');
+    });
+
+    context('there are no ancestors of the type server', () => {
+      it('does not create a dialog', () => {
+        pgBrowser.treeMenu.setSelectedNode([{id: 'level1'}]);
+        backupDialog.draw(null, null, null);
+        expect(alertifySpy['BackupDialog_globals']).not.toHaveBeenCalled();
+        expect(alertifySpy['BackupDialog_server']).not.toHaveBeenCalled();
+      });
+
+      it('display an alert with a Backup Error', () => {
+        backupDialog.draw(null, [rootNode], null);
+        expect(alertifySpy.alert).toHaveBeenCalledWith(
+          'Backup Error',
+          'Please select server or child node from the browser tree.'
+        );
+      });
+    });
+
+    context('there is an ancestor of the type server', () => {
+      context('no preference can be found', () => {
+        beforeEach(() => {
+          pgBrowser.get_preference.and.returnValue(undefined);
+        });
+
+        context('server is a ppas server', () => {
+          it('display an alert with "Backup Error"', () => {
+            backupDialog.draw(null, [serverTreeNode], null);
+            expect(alertifySpy.alert).toHaveBeenCalledWith(
+              'Backup Error',
+              'Failed to load preference pg_bin_dir of module paths'
+            );
+          });
+        });
+
+        context('server is not a ppas server', () => {
+          it('display an alert with "Backup Error"', () => {
+            backupDialog.draw(null, [ppasServerTreeNode], null);
+            expect(alertifySpy.alert).toHaveBeenCalledWith(
+              'Backup Error',
+              'Failed to load preference ppas_bin_dir of module paths'
+            );
+          });
+        });
+      });
+
+      context('preference can be found', () => {
+        context('binary folder is not configured', () => {
+          beforeEach(() => {
+            pgBrowser.get_preference.and.returnValue({});
+          });
+
+          context('server is a ppas server', () => {
+            it('display an alert with "Configuration required"', () => {
+              backupDialog.draw(null, [serverTreeNode], null);
+              expect(alertifySpy.alert).toHaveBeenCalledWith(
+                'Configuration required',
+                'Please configure the PostgreSQL Binary Path in the Preferences dialog.'
+              );
+            });
+          });
+
+          context('server is not a ppas server', () => {
+            it('display an alert with "Configuration required"', () => {
+              backupDialog.draw(null, [ppasServerTreeNode], null);
+              expect(alertifySpy.alert).toHaveBeenCalledWith(
+                'Configuration required',
+                'Please configure the EDB Advanced Server Binary Path in the Preferences dialog.'
+              );
+            });
+          });
+        });
+
+        context('binary folder is configured', () => {
+          let globalResizeToSpy;
+          let serverResizeToSpy;
+          beforeEach(() => {
+            globalResizeToSpy = jasmine.createSpyObj('globals', ['resizeTo']);
+            alertifySpy['BackupDialog_globals'].and
+              .returnValue(globalResizeToSpy);
+            serverResizeToSpy = jasmine.createSpyObj('server', ['resizeTo']);
+            alertifySpy['BackupDialog_server'].and
+              .returnValue(serverResizeToSpy);
+            pgBrowser.get_preference.and.returnValue({value: '/some/path'});
+          });
+
+          context('dialog for global backup', () => {
+            it('displays the dialog', () => {
+              backupDialog.draw(null, [serverTreeNode], {globals: true});
+              expect(alertifySpy['BackupDialog_globals']).toHaveBeenCalledWith(true);
+              expect(globalResizeToSpy.resizeTo).toHaveBeenCalledWith('60%', '50%');
+            });
+          });
+
+          context('dialog for global backup', () => {
+            it('displays the dialog', () => {
+              backupDialog.draw(null, [serverTreeNode], {server: true});
+              expect(alertifySpy['BackupDialog_server']).toHaveBeenCalledWith(true);
+              expect(serverResizeToSpy.resizeTo).toHaveBeenCalledWith('60%', '50%');
+            });
+          });
+        });
+      });
+    });
+  });
+
+  describe('#dialogFactory', () => {
+    describe('#prepare', () => {
+      let backupJQueryContainer;
+      let viewSchema;
+      let generatedBackupModel;
+      let backupNodeChildNode;
+      beforeEach(() => {
+        backupJQueryContainer = jasmine.createSpyObj('backupJQueryContainer', ['get']);
+        backupJQueryContainer.get.and.returnValue(backupJQueryContainer);
+        viewSchema = {};
+        generatedBackupModel = {};
+        backupNode.__internal = {
+          buttons: [
+            {}, {},
+            {
+              element: {
+                disabled: false,
+              }
+            }
+          ]
+        };
+        backupNode.elements = {
+          body: {
+            childNodes: [
+              {}
+            ]
+          },
+          content: jasmine.createSpyObj('content', ['appendChild']),
+        };
+
+        backform.generateViewSchema.and.returnValue(viewSchema);
+        backupModelSpy.and.returnValue(generatedBackupModel);
+
+        backupDialog = new BackupDialog(
+          pgBrowser,
+          jquerySpy,
+          alertifySpy,
+          backupModelSpy,
+          backform
+        );
+
+        backupNodeChildNode = jasmine.createSpyObj('something', ['addClass']);
+
+        jquerySpy.and.callFake((selector) => {
+          if (selector === '<div class=\'backup_dialog\'></div>') {
+            return backupJQueryContainer;
+          } else if (selector === backupNode.elements.body.childNodes[0]) {
+            return backupNodeChildNode;
+          }
+        })
+      });
+
+      context('selected tree node has no data', () => {
+        beforeEach(() => {
+          pgBrowser.treeMenu.setSelectedNode([noDataNode]);
+          const dialog = backupDialog.dialogFactory('Some title', 'globals');
+          Object.assign(dialog, backupNode).prepare();
+        });
+
+        it('does not create a backform dialog', () => {
+          expect(backform.Dialog).not.toHaveBeenCalledWith();
+        });
+
+        it('disables the button submit button until a filename is selected', () => {
+          expect(backupNode.__internal.buttons[2].element.disabled).toBe(true);
+        });
+      });
+
+      context('no tree element is selected', () => {
+        beforeEach(() => {
+          const dialog = backupDialog.dialogFactory('Some title', 'globals');
+          Object.assign(dialog, backupNode).prepare();
+        });
+
+        it('does not create a backform dialog', () => {
+          expect(backform.Dialog).not.toHaveBeenCalledWith();
+        });
+
+        it('disables the button submit button until a filename is selected', () => {
+          expect(backupNode.__internal.buttons[2].element.disabled).toBe(true);
+        });
+      });
+
+      context('tree element is selected', () => {
+        let treeHierarchyInformation;
+        let dialogSpy;
+        beforeEach(() => {
+          treeHierarchyInformation = {
+            server: {
+              _type: 'server',
+              _id: 10,
+              priority: 0,
+            }
+          };
+          pgBrowser.treeMenu.setSelectedNode([serverTreeNode]);
+          pgBrowser.Nodes['server'].getTreeNodeHierarchy.and
+            .returnValue(treeHierarchyInformation);
+          dialogSpy = jasmine.createSpyObj('newView', ['render']);
+          dialogSpy.$el = jasmine.createSpyObj('$el', ['find']);
+          dialogSpy.model = jasmine.createSpyObj('model', ['on'])
+          dialogSpy.$el.find.and.returnValue([]);
+
+          backform.Dialog.and.returnValue(dialogSpy);
+
+          const dialog = backupDialog.dialogFactory('Some title', 'globals');
+          Object.assign(dialog, backupNode).prepare();
+        });
+
+        it('creates a backform dialog and displays it', () => {
+          expect(backform.Dialog).toHaveBeenCalledWith({
+            el: backupJQueryContainer,
+            model: generatedBackupModel,
+            schema: viewSchema,
+          });
+
+          expect(dialogSpy.render).toHaveBeenCalled();
+        });
+
+        it('add alertify classes to backup node childnode', () => {
+          expect(backupNodeChildNode.addClass)
+            .toHaveBeenCalledWith('alertify_tools_dialog_properties obj_properties');
+        });
+
+        it('disables the button submit button until a filename is selected', () => {
+          expect(backupNode.__internal.buttons[2].element.disabled).toBe(true);
+        });
+
+        it('generates a new backup model', () => {
+          expect(backupModelSpy).toHaveBeenCalledWith(
+            {type: 'globals'},
+            {node_info: treeHierarchyInformation}
+          );
+        });
+
+        it('add the new dialog to the backup node HTML', () => {
+          expect(backupNode.elements.content.appendChild).toHaveBeenCalledWith(backupJQueryContainer);
+        });
+      });
+    });
+
+    describe('#onButtonClicked', () => {
+      let backupJQueryContainer;
+      let backupNodeChildNode;
+      let dialog;
+      let networkMock;
+
+      beforeEach(() => {
+        networkMock = new MockAdapter(axios);
+        backupJQueryContainer = jasmine.createSpyObj('backupJQueryContainer', ['get']);
+        backupJQueryContainer.get.and.returnValue(backupJQueryContainer);
+        pgBrowser.showHelp = jasmine.createSpy('showHelp');
+        alertifySpy = jasmine.createSpyObj('alertify', ['success', 'alert']);
+
+        backupDialog = new BackupDialog(
+          pgBrowser,
+          jquerySpy,
+          alertifySpy,
+          backupModelSpy,
+          backform
+        );
+
+        backupNodeChildNode = jasmine.createSpyObj('something', ['addClass']);
+
+        dialog = Object.assign(backupDialog.dialogFactory('Some title', 'server'), backupNode);
+      });
+
+      afterEach(() => {
+        networkMock.restore();
+      });
+
+      context('dialog help button was pressed', () => {
+        let networkCalled;
+        beforeEach(() => {
+          pgBrowser.treeMenu.setSelectedNode([serverTreeNode]);
+          networkCalled = false;
+          networkMock.onAny(/.+/).reply(() => {
+            networkCalled = true;
+            return [200, {}];
+          });
+
+          const event = {
+            button: {
+              element: {
+                name: 'dialog_help',
+                getAttribute: (attributeName) => {
+                  if (attributeName === 'url') {
+                    return 'http://someurl';
+                  } else if (attributeName === 'label') {
+                    return 'some label';
+                  }
+                }
+              }
+            }
+          };
+          dialog.callback(event);
+        });
+
+        it('displays help for dialog', () => {
+          expect(pgBrowser.showHelp).toHaveBeenCalledWith(
+            'dialog_help',
+            'http://someurl',
+            pgBrowser.Nodes['server'],
+            serverTreeNode,
+            'some label'
+          )
+        });
+
+        it('does not start the backup', () => {
+          expect(networkCalled).toBe(false);
+        });
+      });
+
+      context('object help button was pressed', () => {
+        let networkCalled;
+        beforeEach(() => {
+          pgBrowser.treeMenu.setSelectedNode([serverTreeNode]);
+          networkCalled = false;
+          networkMock.onAny(/.+/).reply(() => {
+            networkCalled = true;
+            return [200, {}];
+          });
+
+          const event = {
+            button: {
+              element: {
+                name: 'object_help',
+                getAttribute: (attributeName) => {
+                  if (attributeName === 'url') {
+                    return 'http://someurl';
+                  } else if (attributeName === 'label') {
+                    return 'some label';
+                  }
+                }
+              }
+            }
+          };
+          dialog.callback(event);
+        });
+
+        it('displays help for dialog', () => {
+          expect(pgBrowser.showHelp).toHaveBeenCalledWith(
+            'object_help',
+            'http://someurl',
+            pgBrowser.Nodes['server'],
+            serverTreeNode,
+            'some label'
+          )
+        });
+
+        it('does not start the backup', () => {
+          expect(networkCalled).toBe(false);
+        });
+      });
+
+      context('backup button was pressed', () => {
+        context('no tree node is selected', () => {
+          let networkCalled;
+          beforeEach(() => {
+            networkCalled = false;
+            networkMock.onAny(/.+/).reply(() => {
+              networkCalled = true;
+              return [200, {}];
+            });
+
+            const event = {
+              button: {
+                'data-btn-name': 'backup',
+                element: {
+                  getAttribute: (attributeName) => {
+                    if (attributeName === 'url') {
+                      return 'http://someurl';
+                    } else if (attributeName === 'label') {
+                      return 'some label';
+                    }
+                  }
+                }
+              }
+            };
+            dialog.callback(event);
+          });
+
+          it('does not start the backup', () => {
+            expect(networkCalled).toBe(false);
+          });
+        });
+
+        context('selected node has no data', () => {
+          let networkCalled;
+          beforeEach(() => {
+            pgBrowser.treeMenu.setSelectedNode([noDataNode]);
+            networkCalled = false;
+            networkMock.onAny(/.+/).reply(() => {
+              networkCalled = true;
+              return [200, {}];
+            });
+
+            const event = {
+              button: {
+                'data-btn-name': 'backup',
+                element: {
+                  getAttribute: (attributeName) => {
+                    if (attributeName === 'url') {
+                      return 'http://someurl';
+                    } else if (attributeName === 'label') {
+                      return 'some label';
+                    }
+                  }
+                }
+              }
+            };
+            dialog.callback(event);
+          });
+
+          it('does not start the backup', () => {
+            expect(networkCalled).toBe(false);
+          });
+        });
+
+        context('selected node has data', () => {
+          beforeEach(() => {
+            pgBrowser.treeMenu.setSelectedNode([serverTreeNode]);
+            pgBrowser.Events = jasmine.createSpyObj('Events', ['trigger']);
+
+            backupNode.view = {
+              model: new FakeModel(),
+            };
+            backupNode.view.model.set('dqoute', false);
+            backupNode.view.model.set('file', 'test');
+            backupNode.view.model.set('type', 'globals');
+            backupNode.view.model.set('verbose', true);
+
+            const event = {
+              button: {
+                'data-btn-name': 'backup',
+                element: {
+                  getAttribute: (attributeName) => {
+                    if (attributeName === 'url') {
+                      return 'http://someurl';
+                    } else if (attributeName === 'label') {
+                      return 'some label';
+                    }
+                  }
+                }
+              }
+            };
+            Object.assign(dialog, backupNode).callback(event);
+          });
+          context('creation of backup job successfull', () => {
+            let dataSentToServer;
+            beforeEach(() => {
+              networkMock.onPost('/backup/job/10').reply((request) => {
+                dataSentToServer = request.data;
+                return [200, {}];
+              });
+            });
+
+            it('creates an success alert box', (done) => {
+              setTimeout(() => {
+                expect(alertifySpy.success).toHaveBeenCalledWith('Backup job' +
+                  ' created.', 5);
+                done();
+              }, 0);
+            });
+
+            it('trigger background process', (done) => {
+              setTimeout(() => {
+                expect(pgBrowser.Events.trigger).toHaveBeenCalledWith(
+                  'pgadmin-bgprocess:created',
+                  jasmine.anything()
+                );
+                done();
+              }, 0);
+            });
+
+            it('send correct data to server', () => {
+              expect(dataSentToServer).toEqual(JSON.stringify({
+                dqoute: false,
+                file: 'test',
+                type: 'globals',
+                verbose: true
+              }));
+            });
+          });
+
+          context('error creating backup job', () => {
+            beforeEach(() => {
+              const response = {
+                errormsg: 'some error message'
+              };
+
+              networkMock.onPost('/backup/job/10').reply(() => {
+                return [500, response];
+              });
+            });
+
+            it('creates an alert box', (done) => {
+              setTimeout(() => {
+                expect(alertifySpy.alert).toHaveBeenCalledWith('Backup job' +
+                  ' failed.', 'some error message');
+                done();
+              }, 0);
+            });
+          });
+        });
+      });
+    });
+  });
+});
diff --git a/web/regression/javascript/backup/menu_utils_spec.js b/web/regression/javascript/backup/menu_utils_spec.js
new file mode 100644
index 00000000..8f776976
--- /dev/null
+++ b/web/regression/javascript/backup/menu_utils_spec.js
@@ -0,0 +1,167 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2018, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+
+import {TreeFake} from "../tree/tree_fake";
+import {
+  menuEnabledServer,
+  menuEnabled
+} from "../../../pgadmin/static/js/backup/menu_utils";
+
+const context = describe;
+
+describe('backup.menuUtils', () => {
+  describe('#menuEnabled', () => {
+    let ourBrowser;
+    beforeEach(() => {
+      const tree = new TreeFake();
+      ourBrowser = {
+        treeMenu: tree,
+      };
+      tree.addNewNode('level1', {}, []);
+      tree.addNewNode('level1.1', {_type: 'catalog'}, ['level1']);
+      tree.addNewNode('level1.1.1', {_type: 'database'}, ['level1', 'level1.1']);
+      tree.addNewNode('level1.2', {_type: 'bamm'}, ['level1']);
+      tree.addNewNode('level1.2.1', {
+        _type: 'database',
+        allowConn: true
+      }, ['level1', 'level1.2']);
+      tree.addNewNode('level1.2.2', {
+        _type: 'database',
+        allowConn: false
+      }, ['level1', 'level1.2']);
+      tree.addNewNode('level1.2.3', {
+        _type: 'table'
+      }, ['level1', 'level1.2']);
+
+      tree.addNewNode('level2', {}, []);
+      tree.addNewNode('level2.1', null, ['level2']);
+      tree.addNewNode('level2.1.1', {}, ['level2', 'level2.1']);
+    });
+
+    context('When the current node is a root node', () => {
+      it('return false', () => {
+        expect(menuEnabled.apply(ourBrowser, [{}, [{id: 'level1'}]])).toBe(false);
+      });
+    });
+
+    context('when current node does not exist', () => {
+      it('return false', () => {
+        expect(menuEnabled.apply(ourBrowser, [{}, [{id: 'bamm'}]])).toBe(false);
+      });
+    });
+
+    context('When the current node is not a root node', () => {
+      context('parent data does not exist', () => {
+        it('returns false', () => {
+          expect(menuEnabled.apply(ourBrowser, [{}, [{id: 'level2.1.1'}]])).toBe(false);
+        });
+      });
+
+      context('parent as data', () => {
+        context('the current node type is in the supported node types', () => {
+          context('the parent is of the type catalog', () => {
+            it('returns false', () => {
+              expect(menuEnabled.apply(ourBrowser, [
+                {_type: 'schema'},
+                [{id: 'level1.1.1'}]
+              ])).toBe(false);
+            });
+          });
+          context('the parent is not of the type catalog', () => {
+            context('current node is of the type database', () => {
+              context('current node allows connection', () => {
+                it('returns true', () => {
+                  expect(menuEnabled.apply(ourBrowser, [{
+                    _type: 'database',
+                    allowConn: true
+                  }, [{id: 'level1.2.1'}]])).toBe(true);
+                });
+              });
+              context('current node do not allow connection', () => {
+                it('returns false', () => {
+                  expect(menuEnabled.apply(ourBrowser, [{
+                    _type: 'database',
+                    allowConn: false
+                  }, [{id: 'level1.2.2'}]])).toBe(false);
+                });
+              });
+            });
+            context('current node is not of the type database', () => {
+              it('returns true', () => {
+                expect(menuEnabled.apply(ourBrowser, [{
+                  _type: 'schema'
+                }, [{id: 'level1.2.3'}]])).toBe(true);
+              });
+            });
+          });
+        });
+        context('the current node type is not in the supported node types', () => {
+          it('returns false', () => {
+            expect(menuEnabled.apply(ourBrowser, [{_type: 'catalog'}, [{id: 'level1.1'}]])).toBe(false);
+          });
+        });
+      });
+    });
+
+    context('provided node data is undefined', () => {
+      it('returns false', () => {
+        expect(menuEnabled.apply(ourBrowser, [undefined, [{id: 'level1'}]])).toBe(false);
+      });
+    });
+
+    context('provided node data is null', () => {
+      it('returns false', () => {
+        expect(menuEnabled.apply(ourBrowser, [null, [{id: 'level1'}]])).toBe(false);
+      });
+    });
+  });
+
+  describe('#menuEnabledServer', () => {
+    let ourBrowser;
+    beforeEach(() => {
+      const tree = new TreeFake();
+      ourBrowser = {
+        treeMenu: tree,
+      };
+    });
+
+    context('provided node data is undefined', () => {
+      it('returns false', () => {
+        expect(menuEnabledServer(undefined)).toBe(false);
+      });
+    });
+
+    context('provided node data is null', () => {
+      it('returns false', () => {
+        expect(menuEnabledServer(null)).toBe(false);
+      });
+    });
+
+    context('current node type is not of the type server', () => {
+      it('returns false', () => {
+        expect(menuEnabledServer({_type: 'schema'})).toBe(false);
+      });
+    });
+
+    context('current node type is of the type server', () => {
+      context('is connected', () => {
+        it('returns true', () => {
+          expect(menuEnabledServer({_type: 'server', connected: true})).toBe(true);
+        });
+      });
+      context('is not connected', () => {
+        it('returns false', () => {
+          expect(menuEnabledServer({_type: 'server', connected: false})).toBe(false);
+        });
+      });
+    });
+  });
+});
+
diff --git a/web/regression/javascript/datagrid/get_panel_title_spec.js b/web/regression/javascript/datagrid/get_panel_title_spec.js
new file mode 100644
index 00000000..3baedaa1
--- /dev/null
+++ b/web/regression/javascript/datagrid/get_panel_title_spec.js
@@ -0,0 +1,79 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2018, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import {getPanelTitle} from "../../../pgadmin/static/js/datagrid/get_panel_title";
+import {TreeFake} from "../tree/tree_fake";
+
+const context = describe;
+const xcontext = xdescribe;
+
+describe('#getPanelTitle', () => {
+  let pgBrowser;
+  let tree;
+  beforeEach(() => {
+    tree = new TreeFake();
+    pgBrowser = {
+      treeMenu: tree,
+      Nodes: {
+        server: {
+          hasId: true,
+          _type: 'server',
+        },
+        database: {
+          hasId: true,
+          _type: 'database',
+        },
+      }
+    };
+  });
+
+  context('selected node does not belong to a server', () => {
+    it('returns undefined', () => {
+      tree.addNewNode('level1', {_type: 'server_groups'}, []);
+      tree.addNewNode('level1.1', {_type: 'other'}, ['level1']);
+      tree.setSelectedNode([{id: 'level1'}]);
+      expect(getPanelTitle(pgBrowser)).toBeUndefined();
+    });
+  });
+
+  context('selected node belong to a server', () => {
+    context('selected node does not belong to a database', () => {
+      it('returns the server label and the username', () => {
+        tree.addNewNode('level1', {
+          _type: 'server',
+          db: 'other db label',
+          user: {name: 'some user name'},
+          label: 'server label'
+        }, []);
+        tree.setSelectedNode([{id: 'level1'}]);
+        expect(getPanelTitle(pgBrowser))
+          .toBe('other db label on some user name@server label');
+      });
+    });
+
+    context('selected node belongs to a database', () => {
+      it('returns the database label and the username', () => {
+        tree.addNewNode('level1', {
+          _type: 'server',
+          db: 'other db label',
+          user: {name: 'some user name'},
+          label: 'server label'
+        }, []);
+        tree.addNewNode('level1.1', {
+          _type: 'database',
+          label: 'db label'
+        }, ['level1']);
+        tree.addNewNode('level1.1.1', {_type: 'table'}, ['level1', 'level1.1']);
+        tree.setSelectedNode([{id: 'level1.1.1'}]);
+        expect(getPanelTitle(pgBrowser))
+          .toBe('db label on some user name@server label');
+      });
+    });
+  });
+});
